{ The functional interface to the motor controller is done by a dual port ram }
{ sample:	the time between iterations of the pid loop, see prescale and postscale }
{ counts:	encoder counts ppr*4 }
{ UNITS }
{ despos		encoder counts }
{ pwm		8.8 signed number, only integer part used for output }
{ velocity	8.24 counts per sample (127 max motor counts per sample) }
{ accel		8.24 counts per sample per sample	  B.BBB }
{ accelfract	is the fractional part of accel           0.000BB }
{ dela		added to accelfract and accel each sample 0.00000BBBB }
{ avgvel		8.8 velocity units }
{ TYPES (contents of ram address) }
{ 	<blank>	number of bits is hardware dependent	 }
{ 	ptr	10 bit address pointer }
{ 	flag	16 bit value 0 is false, nonzero is true }
{ 	uint	16 bit unsigned value 0..65535 }
{ 	int	16 bit signed value -32768..32767 }
{ 	ulong	32 bit unsigned value 0..4294967295 }
{ 	long	32 bit signed value -2147483648..2147483647 }
{ 	double	64 bit signed value -1.8E19..1.8E19 }
{ PARAMETER	VALUE	TYPE	FUNCTION }
nullLoc                  =      0;              { (ptr) uninitialized pointers point to dummy }
majorrevLoc              =      2;              { updated when parameters change, hi byte }
minorrevLoc              =      4;              { lo byte }
dummyLoc                 =      0;              { (uint) default pointers point here  }
goLoc                    =      1;              { (flag) set true to start move }
pidLoc                   =      2;              { (flag) set true to enable pid  }
profileLoc               =      3;              { (flag) set true to enable profile generator }
extprofileLoc            =      4;              { (flag) set true for host to control velocity }
dirinvLoc                =      5;              { (flag) set true to invert motor drive polarity }
nextmotLoc               =      6;              { (flag) set true to copy motion block, becomes false when copy complete }
nextfilLoc               =      7;              { (flag) set true to copy filter block, becomes false when copy complete }
homeLoc                  =      8;              { (flag) becomes true when home has occured }
motionLoc                =      9;              { (flag) becomes when velocity = 0 }
slewLoc                  =      10;             { (flag) becomes true when maximum velocity is reached }
errorLoc                 =      11;             { (flag) becomes true when excessive position or pwm error occurs }
eventsLoc                =      12;             { (uint) number of events 16 max }
maxpwmLoc                =      13;             { (uint) pwm limited to this value }
exposerrLoc              =      14;             { (uint) excessive position error limit <32767 }
expwmerrLoc              =      15;             { (uint) excessive pwm count limit }
avgvelLoc                =      16;             { (int) average velocity 8.8 }
maxnegerrLoc             =      17;             { (int) max negative error }
maxposerrLoc             =      18;             { (int) max positive error }
actvelLoc                =      19;             { (int) actual velocity }
bnderrLoc                =      20;             { (int) short bounded(error_long) }
{ reserved	21 }
extvelocityLoc           =      22;             { (ptr) pointer to velocity parameter }
followLoc                =      23;             { (ptr) pointer to desired position }
gearpparamLoc            =      24;             { (ptr) pointer to primary geared parameter }
gearsparamLoc            =      25;             { (ptr) pointer to secondary geared parameter }
gearpLoc                 =      26;             { (long) primary gear ratio 8.24 }
gearsLoc                 =      28;             { (long) secondary gear ratio 8.24 }
gearpoffsetLoc           =      30;             { (long) primary offset }
gearsoffsetLoc           =      32;             { (long) secondary offset }
preslewvelLoc            =      34;             { (long) velocity before slew starts or maximum velocity }
preslewposLoc            =      36;             { (long) position before slew starts or maximum velocity }
{ reserved	38	 }
{ reserved	39 }
{ 32bit user parameters }
homepospLoc              =      40;             { (long) position loaded when primary index occurs }
homepossLoc              =      42;             { (long) position loaded when seconday index occurs }
phasekLoc                =      44;             { (long) phase konstant }
phaseaLoc                =      46;             { (long) phase accumulator, phasek is added to phasea each sample }
encpLoc                  =      48;             { (long) primary encoder, read only }
encsLoc                  =      50;             { (long) secondary encoder, read only }
velocityLoc              =      52;             { (long) current profile velocity }
fixupLoc                 =      54;             { (long) profile generator errror }
{ filter param }
filterblockLoc           =      56;             { begining of filter block }
kkLoc                    =      56;             { (int) pwm offset, initial pwm value }
kffLoc                   =      57;             { (uint) friction in the direction of motion }
kpLoc                    =      58;             { (uint) kpd*error added to pwm }
kdLoc                    =      59;             { (uint) kdd*actualvelocity added to pwm }
kaLoc                    =      60;             { (uint) unused accel error }
kiLoc                    =      61;             { (ulong) ki*error added to integralq each sample, high word added to pwm }
kihLoc                   =      62;             { (uint) high word of ki }
kilLoc                   =      63;             { (uint) high word limit of ki, 32767 max }
kf0Loc                   =      64;             { (uint) (unimplemented) spring }
kf1Loc                   =      65;             { (uint) velocity ff }
kf2Loc                   =      66;             { (uint) accel ff }
kf3Loc                   =      67;             { (uint) unused }
kdfilLoc                 =      68;             { (uint) amount of filtering 0..32767 }
posencLoc                =      69;             { (ptr) pointer to position encoder }
velencLoc                =      70;             { (ptr) pointer to velocity encoder }
nextfilblockLoc          =      71;             { (ptr) pointer to next filter block }
{ motion parameters with breakpoint registers }
motionblockLoc           =      72;             { beginning of motion block }
nextposLoc               =      72;             { (long) where we want to go next }
slewlimitLoc             =      74;             { (long) slew speed limit, 2^23-1 max for kf1,kf2 }
desvelLoc                =      76;             { (long) desired velocity		 }
accelLoc                 =      78;             { (long) acceleration, if 0 then no motion }
delaLoc                  =      80;             { (long) delta accel, added to accel each sample }
breakpointLoc            =      82;             { (long) local breakpoint value }
breakaLoc                =      84;             { (ptr) pointer for compare event  }
breakbLoc                =      85;             { (ptr) pointer for compare event }
nextmotblockLoc          =      86;             { (ptr) pointer to next move block }
userLoc                  =      87;             { (uint)  }
{ 64bit internal use only }
desposfLoc               =      88;             { (double) fractional part of profile position }
desposLoc                =      90;             { (long) profile position }
{ 32bit internal use only }
pwmLoc                   =      92;             { (int) pwm value }
{ reserved	93  }
deltaLoc                 =      94;             { (long) velq - velocityq  }
lastvelocityLoc          =      96;             { (long) old velocity }
checkposLoc              =      98;             { (long) checking position for done }
decelposLoc              =      100;            { (long) position to start decel }
{ 48bit number internal use only }
integralLoc              =      102;            { (long) integral error accumulator }
integralovfLoc           =      104;            { (int) overflow for integral }
{ 16bit internal use only }
pwmcntrLoc               =      105;            { (uint) counter of full scale pwm }
resetLoc                 =      106;            { (flag) true when hardware counter is initialized }
accelfractLoc            =      107;            { (int) fractional part of accel for delaq }
oldgoLoc                 =      108;            { (flag) internal }
oldpidLoc                =      109;            { (flag) internal }
lastposLoc               =      110;            { (uint) last profile position low half }
skipLoc                  =      111;            { (flag) skip position update once only }
{ user ram }
block9Loc                =      112;            
event1Loc                =      112;            
event2Loc                =      120;            
block8Loc                =      128;            
event3Loc                =      128;            
event4Loc                =      136;            
block7Loc                =      144;            
event5Loc                =      144;            
event6Loc                =      152;            
block6Loc                =      160;            
event7Loc                =      160;            
event8Loc                =      168;            
block5Loc                =      176;            
event9Loc                =      176;            
event10Loc               =      184;            
block4Loc                =      192;            
event11Loc               =      192;            
event12Loc               =      200;            
block3Loc                =      208;            
event13Loc               =      208;            
event14Loc               =      216;            
block2Loc                =      224;            
event15Loc               =      224;            
event16Loc               =      232;            
block1Loc                =      240;            
event17Loc               =      240;            
event18Loc               =      248;            
{ global ram }
gevent1Loc               =      256;            { host events }
gevent2Loc               =      264;            
gevent3Loc               =      272;            
gevent4Loc               =      280;            
gevent5Loc               =      288;            
gevent6Loc               =      296;            
gevent7Loc               =      304;            
gevent8Loc               =      312;            
gevent9Loc               =      320;            
gevent10Loc              =      328;            
gevent11Loc              =      336;            
gevent12Loc              =      344;            
gevent13Loc              =      352;            
gevent14Loc              =      360;            
gevent15Loc              =      368;            
gevent16Loc              =      376;            
gevent17Loc              =      384;            
gevent18Loc              =      392;            
gevent19Loc              =      400;            
gevent20Loc              =      408;            
gevent21Loc              =      416;            
gevent22Loc              =      424;            
gevent23Loc              =      432;            
gevent24Loc              =      440;            
{ geared parameter }
gearedp0Loc              =      448;            { (long) axis 0 primary geared }
geareds0Loc              =      450;            { (long) axis 0 seconday geared }
gearedp1Loc              =      452;            { (long) axis 1 primary geared }
geareds1Loc              =      454;            { (long) axis 1 seconday geared }
gearedp2Loc              =      456;            { (long) axis 2 primary geared }
geareds2Loc              =      458;            { (long) axis 2 seconday geared }
gearedp3Loc              =      460;            { (long) axis 3 primary geared }
geareds3Loc              =      462;            { (long) axis 3 seconday geared }
gearedp4Loc              =      464;            { (long) axis 4 primary geared, 8 axis only }
geareds4Loc              =      466;            { (long) axis 4 seconday geared, 8 axis only }
gearedp5Loc              =      468;            { (long) axis 5 primary geared, 8 axis only }
geareds5Loc              =      470;            { (long) axis 5 seconday geared, 8 axis only }
gearedp6Loc              =      472;            { (long) axis 6 primary geared, 8 axis only }
geareds6Loc              =      474;            { (long) axis 6 seconday geared, 8 axis only }
gearedp7Loc              =      476;            { (long) axis 7 primary geared, 8 axis only }
geareds7Loc              =      478;            { (long) axis 7 seconday geared, 8 axis only }
gphasekLoc               =      480;            { (long) gphase konstant }
gphaseaLoc               =      482;            { (long) gphase accumulator, gphasek is added to gphasea each sample }
ledaxisLoc               =      484;            { (ptr) axis for leds to monitor }
ledLoc                   =      485;            { (ptr) parameter for leds to monitor, if not zero }
beeperLoc                =      486;            { (ptr) beep uses what this points to, if not zero }
timeoutLoc               =      487;            { (flag) incremented each time we haven't finished before the next sample }
proctimerLoc             =      488;            { (uint) read proctimer here }
geventsLoc               =      489;            { (uint) number of global events 16 max }
axisLoc                  =      490;            { (ptr) the current axis }
{ these locations are reserved, do not use }
greservedstartLoc        =      491;            
greservedendLoc          =      510;            
swrevisionLoc            =      511;            { (uint) majorrev hibyte minorrev lobyte }
{ ************************* PORTS ********************************************** }
hcommLoc                 =      512;            { (uint) 16bit register (read only) }
clrbusyLoc               =      513;            { write clears host busy flag }
hdataLoc                 =      514;            { (ulong) 32bit register }
axisindexLoc             =      516;            { 4 bits }
statusregLoc             =      517;            { read samplebit and commandpending }
counterpLoc              =      518;            { primary 9bit relative, latched by sample, read only }
cntcntlpLoc              =      519;            { primary counter control reg }
countersLoc              =      520;            { secondary 9bit relative, latch by sample, read only }
cntcntlsLoc              =      521;            { secondary counter control reg }
prescaleLoc              =      524;            { pwm rate = 50mhz/256*(65536/prescale), write only }
postscaleLoc             =      525;            { sample rate = pwm rate/postscale, write only }
pwmgenLoc                =      526;            { pwm generator per axis msbyte of word }
dirLoc                   =      527;            { per axis msbit of word }
enaLoc                   =      528;            { per axis pwm enable }
hproctimerLoc            =      529;            { hardware write to latch then read }
hcommrwLoc               =      531;            { (uint) 16bit register (read write) }
shiftboxLoc              =      532;            { (8.24 * 256) becomes 32.32 out }
{ ports are 12 bits wide }
portaLoc                 =      536;            
portaddrLoc              =      537;            { bit is 1 for output }
portbLoc                 =      538;            
portbddrLoc              =      539;            { bit is 1 for output }
portcLoc                 =      540;            
portcddrLoc              =      541;            { bit is 1 for output }
portdLoc                 =      542;            
portdddrLoc              =      543;            { bit is 1 for output }
porteLoc                 =      544;            
porteddrLoc              =      545;            { bit is 1 for output }
portfLoc                 =      546;            
portfddrLoc              =      547;            { bit is 1 for output }
irqregLoc                =      552;            { irqnumber }
irqenaLoc                =      553;            { write to enable  }
irqdisLoc                =      554;            { write to disable }
{ trace buffer			read		write }
tbuffpushLoc             =      560;            { data		data }
tbuffpopLoc              =      561;            { data		pop pointer }
tbuffmodeLoc             =      562;            { STF		STF		lsb StopOnFull }
tbuffcntLoc              =      563;            { count		reset }
{ multiplier hardware }
mulaLoc                  =      576;            { (int) signed multiplier read/write }
mulbLoc                  =      577;            { (uint) unsigned multiplier read/write }
hprodLoc                 =      578;            { (long) 32bit signed product read only }
hprodhLoc                =      580;            { (uint) 32bit unsigned product hi word read only }
haccLoc                  =      582;            { (long) r/w, adds hprod when write to hprod }
ledsLoc                  =      624;            { byte  }
beepLoc                  =      625;            { msb }
{ hardware constants }
bit14Loc                 =      630;            { (uint) constant }
bit13Loc                 =      631;            { (uint) constant }
zeroLoc                  =      632;            { (int)  }
falseLoc                 =      632;            { (flag)  }
oneLoc                   =      633;            { (int)  }
minusoneLoc              =      634;            { (int)  }
trueLoc                  =      634;            { (flag)  }
signbitLoc               =      635;            { (int)  }
naxisLoc                 =      637;            { number of axis's in hardware }
hwrevisionLoc            =      638;            { hardware revision }
hwtypeLoc                =      639;            { harware type }
{ step motor parameters }
stepLoc                  =      2;              { (flag) set true to enable stepping  }
gearcopyLoc              =      21;             { (flag) enables gearing and copying }
microoffsetLoc           =      56;             { (uint) microstep offset }
{ reserved	57 }
motoriLoc                =      58;             { (uint) current set, 21845/amp hi current (43690/amp lo) }
motorioffsetLoc          =      59;             { (int) phase B current offset }
{ step motor ports }
pwmgenaLoc               =      522;            { pwm generator per axis lsbyte of word }
diraLoc                  =      523;            { per axis bit 9 of word }
pwmgenbLoc               =      526;            { pwm generator per axis lsbyte of word }
dirbLoc                  =      527;            { per axis bit 9 of word }
lookupaddLoc             =      556;            { (uint) sine lookup table address r/w 0..511 }
lookupdataLoc            =      557;            { (uint) sine lookup table data r/w 0..255 }
{ transfer types			axis	parameter	value }
{ Word 	16bit unsigned uint }
{ Double 32bit signed long }
{ Flag	16bit flag  flag }
{ Prog	Program rom file }
{ Conf configure eeprom	file }
