program setsine;
uses crt;
{$I serhost}
{$I parsep}

const
OscOffset = $10;
BaseFreq = 80.1934e6;
BytesPerAcc = 6;

var
TheComport : word;
TheBaudrate : longint;
index : word;
highbit,data : byte;
Frequency : real;
Channel : byte;


procedure BarfOut(s: string);
begin
  writeln;
  writeln(s,chr(7));
  halt(2);
end;

procedure Usage;
begin
  writeln;
  writeln(' SetSine');
  writeln;
  writeln(' USAGE - SetSine chan freq port baud ');
  writeln(' chan is oscillator channel, freq is oscillator frequency');
  writeln(' port is a COM port address and baud is a baud rate');
  writeln;
  halt(2);
end;

procedure GetParms;
var
theport : word;
tempstr : string;
templong : longint;
retcode : integer;
  begin
  if ParamCount < 4 then Usage;
  val(ParamStr(1),Channel,RetCode);
  if retcode <> 0 then BarfOut('Bad channel ');
  if (Channel < 0) or (Channel > 12) then BarfOut('Out of range channel ');
  val(ParamStr(2),Frequency,RetCode);
  if retcode <> 0 then BarfOut('Bad Frequency ');
  if (Frequency < 0) or (Frequency > 10e6) then BarfOut('Out of range frequency ');
  tempstr := ParamStr(3);
  tempstr := UpString(tempstr);
  if not HexLongRead(tempstr,templong) then
  begin
    TheComPort := 0;
    if tempstr = 'COM1' then TheComPort := COM1;
    if tempstr = 'COM2' then TheComPort := COM2;
    if tempstr = 'COM3' then TheComPort := COM3;
    if tempstr = 'COM4' then TheComPort := COM4;
    if TheComPort = 0 then BarfOut('Undecipherable COM port');
  end
  else
  begin
    if (templong <$100) or (templong >$3F8) then
    begin
      BarfOut('Out of range COM port address!');
    end;
    if (templong and 7) <> 0 then
    begin
      BarfOut('Illegal COM port address!');
    end;
    TheComPort := word(templong);
  end;
  if length(ParamStr(4)) <> 0 then
  begin
    tempstr := ParamStr(4);
    val(tempstr,templong,retcode);
    if (templong <300) or (templong >115200) or (retcode <> 0) then
    begin
      BarfOut('Bad baud rate parameter!');
    end
    else
    begin
      TheBaudRate := templong;
    end;
  end;
  InitializeSerInterface(TheComPort,TheBaudRate);
  delay(100);
  TossChars(TheComPort,20);
end;

procedure SetFreq(osc: byte;thefreq : real);
var
freqreal : real;
index : byte;
fbytes : array [1..BytesPerAcc] of byte;
begin
  freqreal := thefreq/BaseFreq;
  for index := 1 to BytesPerAcc do
  begin
    freqreal := frac(freqreal);
    freqreal := freqreal*256;
    fbytes[index] := byte(trunc(freqreal));
  end;
  for index := 1 to BytesPerAcc do
  begin
    WriteDirect(TheComPort,osc*OscOffset+index-1,fbytes[BytesPerAcc +1 -index]);
    Writeln(index-1,':',Hexstring(fbytes[BytesPerAcc +1 -index],2));

  end;
end;


begin
  GetParms;
  if not SerSync(TheComport) then Barfout('7I60 communication error');
  writeln('Card type is ',InquireID(TheComport));
  writeln('Pic Revision is ',InquireRev(TheComport));
  WritePLL(TheComport,06); { set PLL to 80.1934 MHz}
  SetFreq(Channel,Frequency);
end.