const
{ ************************* PORTS ********************************************** }
ififoreadLoc             =      512;            { (uint) immediate fifo }
ififoreadcountLoc        =      513;            { (uint) count of data }
ififoparamLoc            =      514;            { (uint) parameter }
ififoaxisLoc             =      515;            { (uint) axis }
ififowriteLoc            =      516;            { (uint)  }
ififowritecountLoc       =      517;            { (uint)  }
qfiforeadLoc             =      520;            { (uint) queued fifo }
qfiforeadcountLoc        =      521;            { (uint)  }
qfifoparamLoc            =      522;            { (uint)  }
qfifoaxisLoc             =      523;            { (uint)  }
qfifowriteLoc            =      524;            { (uint)  }
qfifowritecountLoc       =      525;            { (uint)  }
cntcntlpLoc              =      531;            { (uint) primary counter control reg }
cntcntlsLoc              =      533;            { (uint) secondary counter control reg }
prescaleLoc              =      534;            { (uint) pwm rate = 50mhz/256*(65536/prescale), write only }
postscaleLoc             =      535;            { (uint) sample rate = pwm rate/postscale, write only }
cntclrpLoc               =      536;            { (uint) write to clear primary counter }
cntclrsLoc               =      537;            { (uint) write to clear secondary counter }
clrclrdpLoc              =      538;            { (uint) clear count cleared bit }
clrclrdsLoc              =      539;            { (uint) clear count cleared bit }
pwmgenaLoc               =      544;            { (uint) pwm generator per axis msbyte of word }
pwmgenbLoc               =      545;            { (uint) pwm generator per axis msbyte of word }
pwmgencLoc               =      546;            { (uint) pwm generator per axis msbyte of word }
diraLoc                  =      547;            { (uint) per axis msbit of word }
dirbLoc                  =      548;            { (uint) per axis msbit of word }
dircLoc                  =      549;            { (uint) per axis msbit of word }
enaLoc                   =      550;            { (uint) per axis pwm enable }
{ ports are 12 bits wide  }
portaLoc                 =      560;            { (uint)  }
portaddrLoc              =      561;            { (uint) bit is 1 for output }
portbLoc                 =      562;            { (uint)  }
portbddrLoc              =      563;            { (uint) bit is 1 for output }
portcLoc                 =      564;            { (uint)  }
portcddrLoc              =      565;            { (uint) bit is 1 for output }
portdLoc                 =      566;            { (uint)  }
portdddrLoc              =      567;            { (uint) bit is 1 for output }
porteLoc                 =      568;            { (uint)  }
porteddrLoc              =      569;            { (uint) bit is 1 for output }
portfLoc                 =      570;            { (uint)  }
portfddrLoc              =      571;            { (uint) bit is 1 for output }
irqsetupregLoc           =      573;            { (uint) irq setup reg }
irqcauseLoc              =      574;            { (uint) write identifier to set  }
{ multiplier hardware }
mulaLoc                  =      576;            { (int) signed multiplier read/write }
mulbLoc                  =      577;            { (uint) unsigned multiplier read/write }
hprodLoc                 =      578;            { (long) 32bit signed product read only }
hprodhLoc                =      580;            { (uint) 16bit unsigned product hi word read only }
hprodmidLoc              =      581;            { (uint) 16bit unsigned product mid word 8.8 }
haccLoc                  =      582;            { (long) r/w, adds signed prod when write to hprod, }
{ 				unsigned prod when write to hprodh }
hmulaLoc                 =      584;            { (long) 32*32=64 }
hmulbLoc                 =      586;            { (long)  }
hlprodLoc                =      584;            { (double)  }
hmulcntLoc               =      591;            { (uint)  }
hdividendLoc             =      592;            { (double) 64/32=32 }
hdivisorLoc              =      596;            { (long)  }
hquotientLoc             =      592;            { (long)  }
hremainderLoc            =      594;            { (long)  }
hdivcntLoc               =      599;            { (uint)  }
hradicandLoc             =      600;            { (double) sqrt(64)=32 }
hrootLoc                 =      600;            { (long)  }
hsqrtcntLoc              =      607;            { (uint)  }
lookupaddLoc             =      608;            { (uint) sine lookup table address r/w 0..511 }
lookupdataLoc            =      609;            { (uint) sine lookup table data r/w left justified }
lookupantidataLoc        =      610;            { (uint) sine lookup table data r/w antiphase left justified }
pfd0Loc                  =      612;            { (uint) 7i32 mode bit }
pfd1Loc                  =      613;            { (uint) 7i32 mode bit }
AltIndexbitLoc           =      614;            { (uint) read alternate index bit for 7I32 }
quadoutrateLoc           =      616;            { (uint) rate register }
quadoutcountLoc          =      617;            { (uint) input pulse count 8 bit }
quadoutmodeLoc           =      618;            { (uint) bit0: output enable, bit1: freerun mode }
ledsLoc                  =      624;            { (uint) byte  }
beepLoc                  =      625;            { (uint) msb }
{ hardware constants	 }
sysclkLoc                =      628;            { (long) CPU clock frequency }
zeroLoc                  =      632;            { (int) constant }
oneLoc                   =      640;            { (int) constant }
falseLoc                 =      632;            { (flag) constant }
minusoneLoc              =      633;            { (int)  }
trueLoc                  =      633;            { (flag)  }
naxisLoc                 =      634;            { (uint) number of axis's in hardware }
hwrevisionLoc            =      635;            { (uint) hwtype in hi byte revision in low byte }
icdfifosizeLoc           =      636;            { (uint) immediate command\data fifo size  }
qcdfifosizeLoc           =      637;            { (uint) queued command\data fifo size  }
irbfifosizeLoc           =      638;            { (uint) immediate readback fifo size }
qrbfifosizeLoc           =      639;            { (uint) queued readback fifo size }
