type
ParameterType = (type_byte,type_ptr,type_flag,type_mask,
type_uint,type_int,type_ulong,type_long,type_double,type_event,
type_ebyte,type_eword,type_lit,type_const,type_enum);
SDMCParamRec = 
record
  ParmName : string[24];
  ParmLoc  : longint;
  ParmType : ParameterType;
end;

const
LastParm = 260;
SDMCParams : array[1 .. LastParm] of SDMCParamRec =
((ParmName : 'nulld'; ParmLoc : 0; ParmType : type_double ),
(ParmName : 'null'; ParmLoc : 0; ParmType : type_ptr ),
(ParmName : 'dummy'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'dummyhi'; ParmLoc : 1; ParmType : type_uint ),
(ParmName : 'go'; ParmLoc : 2; ParmType : type_flag ),
(ParmName : 'pid'; ParmLoc : 3; ParmType : type_flag ),
(ParmName : 'profile'; ParmLoc : 4; ParmType : type_uint ),
(ParmName : 'dist'; ParmLoc : 5; ParmType : type_int ),
(ParmName : 'decel'; ParmLoc : 5; ParmType : type_flag ),
(ParmName : 'dirinv'; ParmLoc : 6; ParmType : type_flag ),
(ParmName : 'filterblock'; ParmLoc : 7; ParmType : type_ptr ),
(ParmName : 'home'; ParmLoc : 9; ParmType : type_flag ),
(ParmName : 'motion'; ParmLoc : 10; ParmType : type_flag ),
(ParmName : 'slew'; ParmLoc : 11; ParmType : type_flag ),
(ParmName : 'error'; ParmLoc : 12; ParmType : type_uint ),
(ParmName : 'errormask'; ParmLoc : 13; ParmType : type_mask ),
(ParmName : 'events'; ParmLoc : 14; ParmType : type_uint ),
(ParmName : 'maxpwm'; ParmLoc : 15; ParmType : type_uint ),
(ParmName : 'avgvel'; ParmLoc : 16; ParmType : type_int ),
(ParmName : 'exposerr'; ParmLoc : 17; ParmType : type_uint ),
(ParmName : 'maxnegerr'; ParmLoc : 18; ParmType : type_int ),
(ParmName : 'maxposerr'; ParmLoc : 19; ParmType : type_int ),
(ParmName : 'driveerror'; ParmLoc : 20; ParmType : type_uint ),
(ParmName : 'posenc'; ParmLoc : 21; ParmType : type_ptr ),
(ParmName : 'velenc'; ParmLoc : 22; ParmType : type_ptr ),
(ParmName : 'actvel'; ParmLoc : 23; ParmType : type_int ),
(ParmName : 'bnderr'; ParmLoc : 24; ParmType : type_int ),
(ParmName : 'extvelocity'; ParmLoc : 25; ParmType : type_ptr ),
(ParmName : 'follow'; ParmLoc : 26; ParmType : type_ptr ),
(ParmName : 'pwm'; ParmLoc : 27; ParmType : type_int ),
(ParmName : 'phaseai'; ParmLoc : 28; ParmType : type_uint ),
(ParmName : 'phasebi'; ParmLoc : 29; ParmType : type_uint ),
(ParmName : 'offseti'; ParmLoc : 30; ParmType : type_uint ),
(ParmName : 'encodercnt'; ParmLoc : 31; ParmType : type_uint ),
(ParmName : 'encfactor'; ParmLoc : 32; ParmType : type_uint ),
(ParmName : 'slipk'; ParmLoc : 33; ParmType : type_int ),
(ParmName : 'phaseshift'; ParmLoc : 34; ParmType : type_flag ),
(ParmName : 'openloop'; ParmLoc : 35; ParmType : type_flag ),
(ParmName : 'homeposp'; ParmLoc : 36; ParmType : type_long ),
(ParmName : 'homeposs'; ParmLoc : 38; ParmType : type_long ),
(ParmName : 'phasek'; ParmLoc : 40; ParmType : type_long ),
(ParmName : 'phasea'; ParmLoc : 42; ParmType : type_long ),
(ParmName : 'encp'; ParmLoc : 44; ParmType : type_long ),
(ParmName : 'encs'; ParmLoc : 46; ParmType : type_long ),
(ParmName : 'desvel'; ParmLoc : 48; ParmType : type_long ),
(ParmName : 'desposd'; ParmLoc : 66; ParmType : type_double ),
(ParmName : 'desposf'; ParmLoc : 66; ParmType : type_long ),
(ParmName : 'despos'; ParmLoc : 68; ParmType : type_long ),
(ParmName : 'velocity'; ParmLoc : 70; ParmType : type_long ),
(ParmName : 'accelf'; ParmLoc : 72; ParmType : type_int ),
(ParmName : 'accel'; ParmLoc : 73; ParmType : type_long ),
(ParmName : 'jerk'; ParmLoc : 75; ParmType : type_long ),
(ParmName : 'breakpoint'; ParmLoc : 77; ParmType : type_long ),
(ParmName : 'nextproblock'; ParmLoc : 79; ParmType : type_ptr ),
(ParmName : 'nextpos'; ParmLoc : 80; ParmType : type_long ),
(ParmName : 'slewlimit'; ParmLoc : 82; ParmType : type_long ),
(ParmName : 'phaselead'; ParmLoc : 84; ParmType : type_int ),
(ParmName : 'motorangle'; ParmLoc : 85; ParmType : type_uint ),
(ParmName : 'motorphase'; ParmLoc : 86; ParmType : type_uint ),
(ParmName : 'homeoffset'; ParmLoc : 87; ParmType : type_int ),
(ParmName : 'calcaccel'; ParmLoc : 88; ParmType : type_long ),
(ParmName : 'delta'; ParmLoc : 90; ParmType : type_long ),
(ParmName : 'fvelocity'; ParmLoc : 92; ParmType : type_uint ),
(ParmName : 'flastvelocity'; ParmLoc : 93; ParmType : type_uint ),
(ParmName : 'flagxor'; ParmLoc : 94; ParmType : type_uint ),
(ParmName : 'flagand'; ParmLoc : 95; ParmType : type_uint ),
(ParmName : 'fractionaccel'; ParmLoc : 96; ParmType : type_long ),
(ParmName : 'halfaccel'; ParmLoc : 96; ParmType : type_long ),
(ParmName : 'fixup'; ParmLoc : 98; ParmType : type_long ),
(ParmName : 'ouraccel'; ParmLoc : 100; ParmType : type_long ),
(ParmName : 'stopathome'; ParmLoc : 102; ParmType : type_flag ),
(ParmName : 'velocityf'; ParmLoc : 103; ParmType : type_int ),
(ParmName : 'integral'; ParmLoc : 104; ParmType : type_long ),
(ParmName : 'integralovf'; ParmLoc : 106; ParmType : type_int ),
(ParmName : 'reset'; ParmLoc : 107; ParmType : type_flag ),
(ParmName : 'olddist'; ParmLoc : 108; ParmType : type_int ),
(ParmName : 'acceln'; ParmLoc : 108; ParmType : type_uint ),
(ParmName : 'lastpos'; ParmLoc : 109; ParmType : type_uint ),
(ParmName : 'oldgo'; ParmLoc : 110; ParmType : type_flag ),
(ParmName : 'oldpid'; ParmLoc : 111; ParmType : type_flag ),
(ParmName : 'firstevent'; ParmLoc : 112; ParmType : type_uint ),
(ParmName : 'eventfirst'; ParmLoc : 112; ParmType : type_uint ),
(ParmName : 'event1'; ParmLoc : 112; ParmType : type_uint ),
(ParmName : 'event2'; ParmLoc : 118; ParmType : type_uint ),
(ParmName : 'event3'; ParmLoc : 124; ParmType : type_uint ),
(ParmName : 'event4'; ParmLoc : 130; ParmType : type_uint ),
(ParmName : 'event5'; ParmLoc : 136; ParmType : type_uint ),
(ParmName : 'event6'; ParmLoc : 142; ParmType : type_uint ),
(ParmName : 'event7'; ParmLoc : 148; ParmType : type_uint ),
(ParmName : 'event8'; ParmLoc : 154; ParmType : type_uint ),
(ParmName : 'event9'; ParmLoc : 160; ParmType : type_uint ),
(ParmName : 'event10'; ParmLoc : 166; ParmType : type_uint ),
(ParmName : 'event11'; ParmLoc : 172; ParmType : type_uint ),
(ParmName : 'event12'; ParmLoc : 178; ParmType : type_uint ),
(ParmName : 'event13'; ParmLoc : 184; ParmType : type_uint ),
(ParmName : 'event14'; ParmLoc : 190; ParmType : type_uint ),
(ParmName : 'event15'; ParmLoc : 196; ParmType : type_uint ),
(ParmName : 'event16'; ParmLoc : 202; ParmType : type_uint ),
(ParmName : 'event17'; ParmLoc : 208; ParmType : type_uint ),
(ParmName : 'event18'; ParmLoc : 214; ParmType : type_uint ),
(ParmName : 'event19'; ParmLoc : 220; ParmType : type_uint ),
(ParmName : 'event20'; ParmLoc : 226; ParmType : type_uint ),
(ParmName : 'event21'; ParmLoc : 232; ParmType : type_uint ),
(ParmName : 'event22'; ParmLoc : 238; ParmType : type_uint ),
(ParmName : 'event23'; ParmLoc : 244; ParmType : type_uint ),
(ParmName : 'event24'; ParmLoc : 250; ParmType : type_uint ),
(ParmName : 'eventlast'; ParmLoc : 250; ParmType : type_uint ),
(ParmName : 'lastevent'; ParmLoc : 250; ParmType : type_uint ),
(ParmName : 'firstgevent'; ParmLoc : 256; ParmType : type_uint ),
(ParmName : 'geventfirst'; ParmLoc : 256; ParmType : type_uint ),
(ParmName : 'gevent1'; ParmLoc : 256; ParmType : type_uint ),
(ParmName : 'gevent2'; ParmLoc : 262; ParmType : type_uint ),
(ParmName : 'gevent3'; ParmLoc : 268; ParmType : type_uint ),
(ParmName : 'gevent4'; ParmLoc : 274; ParmType : type_uint ),
(ParmName : 'gevent5'; ParmLoc : 280; ParmType : type_uint ),
(ParmName : 'gevent6'; ParmLoc : 286; ParmType : type_uint ),
(ParmName : 'gevent7'; ParmLoc : 292; ParmType : type_uint ),
(ParmName : 'gevent8'; ParmLoc : 298; ParmType : type_uint ),
(ParmName : 'gevent9'; ParmLoc : 304; ParmType : type_uint ),
(ParmName : 'gevent10'; ParmLoc : 310; ParmType : type_uint ),
(ParmName : 'gevent11'; ParmLoc : 316; ParmType : type_uint ),
(ParmName : 'gevent12'; ParmLoc : 322; ParmType : type_uint ),
(ParmName : 'gevent13'; ParmLoc : 328; ParmType : type_uint ),
(ParmName : 'gevent14'; ParmLoc : 334; ParmType : type_uint ),
(ParmName : 'gevent15'; ParmLoc : 340; ParmType : type_uint ),
(ParmName : 'gevent16'; ParmLoc : 346; ParmType : type_uint ),
(ParmName : 'gevent17'; ParmLoc : 352; ParmType : type_uint ),
(ParmName : 'gevent18'; ParmLoc : 358; ParmType : type_uint ),
(ParmName : 'gevent19'; ParmLoc : 364; ParmType : type_uint ),
(ParmName : 'gevent20'; ParmLoc : 370; ParmType : type_uint ),
(ParmName : 'gevent21'; ParmLoc : 376; ParmType : type_uint ),
(ParmName : 'gevent22'; ParmLoc : 382; ParmType : type_uint ),
(ParmName : 'gevent23'; ParmLoc : 388; ParmType : type_uint ),
(ParmName : 'gevent24'; ParmLoc : 394; ParmType : type_uint ),
(ParmName : 'gevent25'; ParmLoc : 400; ParmType : type_uint ),
(ParmName : 'gevent26'; ParmLoc : 406; ParmType : type_uint ),
(ParmName : 'gevent27'; ParmLoc : 412; ParmType : type_uint ),
(ParmName : 'gevent28'; ParmLoc : 418; ParmType : type_uint ),
(ParmName : 'gevent29'; ParmLoc : 424; ParmType : type_uint ),
(ParmName : 'gevent30'; ParmLoc : 430; ParmType : type_uint ),
(ParmName : 'gevent31'; ParmLoc : 436; ParmType : type_uint ),
(ParmName : 'gevent32'; ParmLoc : 442; ParmType : type_uint ),
(ParmName : 'gevent33'; ParmLoc : 448; ParmType : type_uint ),
(ParmName : 'gevent34'; ParmLoc : 454; ParmType : type_uint ),
(ParmName : 'gevent35'; ParmLoc : 460; ParmType : type_uint ),
(ParmName : 'gevent36'; ParmLoc : 466; ParmType : type_uint ),
(ParmName : 'geventlast'; ParmLoc : 466; ParmType : type_uint ),
(ParmName : 'lastgevent'; ParmLoc : 466; ParmType : type_uint ),
(ParmName : 'ledaxis'; ParmLoc : 496; ParmType : type_ptr ),
(ParmName : 'led'; ParmLoc : 497; ParmType : type_ptr ),
(ParmName : 'beeper'; ParmLoc : 498; ParmType : type_ptr ),
(ParmName : 'proctimer'; ParmLoc : 499; ParmType : type_uint ),
(ParmName : 'timeout'; ParmLoc : 500; ParmType : type_uint ),
(ParmName : 'gevents'; ParmLoc : 501; ParmType : type_uint ),
(ParmName : 'axis'; ParmLoc : 502; ParmType : type_ptr ),
(ParmName : 'sync'; ParmLoc : 503; ParmType : type_flag ),
(ParmName : 'gphasek'; ParmLoc : 504; ParmType : type_long ),
(ParmName : 'gphasea'; ParmLoc : 506; ParmType : type_long ),
(ParmName : 'gphasef'; ParmLoc : 508; ParmType : type_flag ),
(ParmName : 'cputype'; ParmLoc : 509; ParmType : type_uint ),
(ParmName : 'controltype'; ParmLoc : 510; ParmType : type_uint ),
(ParmName : 'swrevision'; ParmLoc : 511; ParmType : type_uint ),
(ParmName : 'kk'; ParmLoc : 50; ParmType : type_int ),
(ParmName : 'kff'; ParmLoc : 51; ParmType : type_uint ),
(ParmName : 'kp'; ParmLoc : 52; ParmType : type_uint ),
(ParmName : 'kd'; ParmLoc : 53; ParmType : type_uint ),
(ParmName : 'ka'; ParmLoc : 54; ParmType : type_uint ),
(ParmName : 'ki'; ParmLoc : 55; ParmType : type_ulong ),
(ParmName : 'kih'; ParmLoc : 56; ParmType : type_uint ),
(ParmName : 'kil'; ParmLoc : 57; ParmType : type_uint ),
(ParmName : 'kf0'; ParmLoc : 58; ParmType : type_uint ),
(ParmName : 'kf1'; ParmLoc : 59; ParmType : type_uint ),
(ParmName : 'kf2'; ParmLoc : 60; ParmType : type_uint ),
(ParmName : 'kf3'; ParmLoc : 61; ParmType : type_uint ),
(ParmName : 'kdfil'; ParmLoc : 62; ParmType : type_uint ),
(ParmName : 'driveplus'; ParmLoc : 63; ParmType : type_uint ),
(ParmName : 'driveminus'; ParmLoc : 64; ParmType : type_uint ),
(ParmName : 'nextfilblock'; ParmLoc : 65; ParmType : type_ptr ),
(ParmName : 'ififoread'; ParmLoc : 512; ParmType : type_uint ),
(ParmName : 'ififoreadcount'; ParmLoc : 513; ParmType : type_uint ),
(ParmName : 'ififoparam'; ParmLoc : 514; ParmType : type_uint ),
(ParmName : 'ififoaxis'; ParmLoc : 515; ParmType : type_uint ),
(ParmName : 'ififowrite'; ParmLoc : 516; ParmType : type_uint ),
(ParmName : 'ififowritecount'; ParmLoc : 517; ParmType : type_uint ),
(ParmName : 'qfiforead'; ParmLoc : 520; ParmType : type_uint ),
(ParmName : 'qfiforeadcount'; ParmLoc : 521; ParmType : type_uint ),
(ParmName : 'qfifoparam'; ParmLoc : 522; ParmType : type_uint ),
(ParmName : 'qfifoaxis'; ParmLoc : 523; ParmType : type_uint ),
(ParmName : 'qfifowrite'; ParmLoc : 524; ParmType : type_uint ),
(ParmName : 'qfifowritecount'; ParmLoc : 525; ParmType : type_uint ),
(ParmName : 'cntcntlp'; ParmLoc : 531; ParmType : type_uint ),
(ParmName : 'cntcntls'; ParmLoc : 533; ParmType : type_uint ),
(ParmName : 'prescale'; ParmLoc : 534; ParmType : type_uint ),
(ParmName : 'postscale'; ParmLoc : 535; ParmType : type_uint ),
(ParmName : 'cntclrp'; ParmLoc : 536; ParmType : type_uint ),
(ParmName : 'cntclrs'; ParmLoc : 537; ParmType : type_uint ),
(ParmName : 'clrclrdp'; ParmLoc : 538; ParmType : type_uint ),
(ParmName : 'clrclrds'; ParmLoc : 539; ParmType : type_uint ),
(ParmName : 'pwmgena'; ParmLoc : 544; ParmType : type_uint ),
(ParmName : 'pwmgenb'; ParmLoc : 545; ParmType : type_uint ),
(ParmName : 'pwmgenc'; ParmLoc : 546; ParmType : type_uint ),
(ParmName : 'dira'; ParmLoc : 547; ParmType : type_uint ),
(ParmName : 'dirb'; ParmLoc : 548; ParmType : type_uint ),
(ParmName : 'dirc'; ParmLoc : 549; ParmType : type_uint ),
(ParmName : 'ena'; ParmLoc : 550; ParmType : type_uint ),
(ParmName : 'porta'; ParmLoc : 560; ParmType : type_uint ),
(ParmName : 'portaddr'; ParmLoc : 561; ParmType : type_uint ),
(ParmName : 'portb'; ParmLoc : 562; ParmType : type_uint ),
(ParmName : 'portbddr'; ParmLoc : 563; ParmType : type_uint ),
(ParmName : 'portc'; ParmLoc : 564; ParmType : type_uint ),
(ParmName : 'portcddr'; ParmLoc : 565; ParmType : type_uint ),
(ParmName : 'portd'; ParmLoc : 566; ParmType : type_uint ),
(ParmName : 'portdddr'; ParmLoc : 567; ParmType : type_uint ),
(ParmName : 'porte'; ParmLoc : 568; ParmType : type_uint ),
(ParmName : 'porteddr'; ParmLoc : 569; ParmType : type_uint ),
(ParmName : 'portf'; ParmLoc : 570; ParmType : type_uint ),
(ParmName : 'portfddr'; ParmLoc : 571; ParmType : type_uint ),
(ParmName : 'irqsetupreg'; ParmLoc : 573; ParmType : type_uint ),
(ParmName : 'irqcause'; ParmLoc : 574; ParmType : type_uint ),
(ParmName : 'mula'; ParmLoc : 576; ParmType : type_int ),
(ParmName : 'mulb'; ParmLoc : 577; ParmType : type_uint ),
(ParmName : 'hprod'; ParmLoc : 578; ParmType : type_long ),
(ParmName : 'hprodh'; ParmLoc : 580; ParmType : type_uint ),
(ParmName : 'hprodmid'; ParmLoc : 581; ParmType : type_uint ),
(ParmName : 'hacc'; ParmLoc : 582; ParmType : type_long ),
(ParmName : 'hmula'; ParmLoc : 584; ParmType : type_long ),
(ParmName : 'hmulb'; ParmLoc : 586; ParmType : type_long ),
(ParmName : 'hlprod'; ParmLoc : 584; ParmType : type_double ),
(ParmName : 'hmulcnt'; ParmLoc : 591; ParmType : type_uint ),
(ParmName : 'hdividend'; ParmLoc : 592; ParmType : type_double ),
(ParmName : 'hdivisor'; ParmLoc : 596; ParmType : type_long ),
(ParmName : 'hquotient'; ParmLoc : 592; ParmType : type_long ),
(ParmName : 'hremainder'; ParmLoc : 594; ParmType : type_long ),
(ParmName : 'hdivcnt'; ParmLoc : 599; ParmType : type_uint ),
(ParmName : 'hradicand'; ParmLoc : 600; ParmType : type_double ),
(ParmName : 'hroot'; ParmLoc : 600; ParmType : type_long ),
(ParmName : 'hsqrtcnt'; ParmLoc : 607; ParmType : type_uint ),
(ParmName : 'lookupadd'; ParmLoc : 608; ParmType : type_uint ),
(ParmName : 'lookupdata'; ParmLoc : 609; ParmType : type_uint ),
(ParmName : 'lookupantidata'; ParmLoc : 610; ParmType : type_uint ),
(ParmName : 'pfd0'; ParmLoc : 612; ParmType : type_uint ),
(ParmName : 'pfd1'; ParmLoc : 613; ParmType : type_uint ),
(ParmName : 'AltIndexbit'; ParmLoc : 614; ParmType : type_uint ),
(ParmName : 'quadoutrate'; ParmLoc : 616; ParmType : type_uint ),
(ParmName : 'quadoutcount'; ParmLoc : 617; ParmType : type_uint ),
(ParmName : 'quadoutmode'; ParmLoc : 618; ParmType : type_uint ),
(ParmName : 'leds'; ParmLoc : 624; ParmType : type_uint ),
(ParmName : 'beep'; ParmLoc : 625; ParmType : type_uint ),
(ParmName : 'sysclk'; ParmLoc : 628; ParmType : type_long ),
(ParmName : 'zero'; ParmLoc : 632; ParmType : type_int ),
(ParmName : 'one'; ParmLoc : 640; ParmType : type_int ),
(ParmName : 'false'; ParmLoc : 632; ParmType : type_flag ),
(ParmName : 'minusone'; ParmLoc : 633; ParmType : type_int ),
(ParmName : 'true'; ParmLoc : 633; ParmType : type_flag ),
(ParmName : 'naxis'; ParmLoc : 634; ParmType : type_uint ),
(ParmName : 'hwrevision'; ParmLoc : 635; ParmType : type_uint ),
(ParmName : 'icdfifosize'; ParmLoc : 636; ParmType : type_uint ),
(ParmName : 'qcdfifosize'; ParmLoc : 637; ParmType : type_uint ),
(ParmName : 'irbfifosize'; ParmLoc : 638; ParmType : type_uint ),
(ParmName : 'qrbfifosize'; ParmLoc : 639; ParmType : type_uint ));
