type
ParameterType = (type_byte,type_ptr,type_flag,type_mask,
type_uint,type_int,type_ulong,type_long,type_double,type_event,
type_ebyte,type_eword,type_lit,type_const,type_enum);
SDMCParamRec = 
record
  ParmName : string[24];
  ParmLoc  : longint;
  ParmType : ParameterType;
end;

const
LastParm = 160;
SDMCParams : array[1 .. LastParm] of SDMCParamRec = 
((ParmName : 'null'; ParmLoc : 0; ParmType : type_ptr ),
(ParmName : 'dummy'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'dummyhi'; ParmLoc : 1; ParmType : type_uint ),
(ParmName : 'go'; ParmLoc : 2; ParmType : type_flag ),
(ParmName : 'pid'; ParmLoc : 3; ParmType : type_flag ),
(ParmName : 'profile'; ParmLoc : 4; ParmType : type_uint ),
(ParmName : 'drivemode'; ParmLoc : 5; ParmType : type_flag ),
(ParmName : 'dirinv'; ParmLoc : 6; ParmType : type_flag ),
(ParmName : 'proctimer'; ParmLoc : 7; ParmType : type_uint ),
(ParmName : 'stepdir'; ParmLoc : 8; ParmType : type_flag ),
(ParmName : 'home'; ParmLoc : 9; ParmType : type_flag ),
(ParmName : 'motion'; ParmLoc : 10; ParmType : type_flag ),
(ParmName : 'slew'; ParmLoc : 11; ParmType : type_flag ),
(ParmName : 'error'; ParmLoc : 12; ParmType : type_uint ),
(ParmName : 'errormask'; ParmLoc : 13; ParmType : type_mask ),
(ParmName : 'events'; ParmLoc : 14; ParmType : type_uint ),
(ParmName : 'maxpwm'; ParmLoc : 15; ParmType : type_uint ),
(ParmName : 'avgvel'; ParmLoc : 16; ParmType : type_int ),
(ParmName : 'exposerr'; ParmLoc : 17; ParmType : type_uint ),
(ParmName : 'maxnegerr'; ParmLoc : 18; ParmType : type_int ),
(ParmName : 'maxposerr'; ParmLoc : 19; ParmType : type_int ),
(ParmName : 'driveerror'; ParmLoc : 20; ParmType : type_uint ),
(ParmName : 'posenc'; ParmLoc : 21; ParmType : type_ptr ),
(ParmName : 'velenc'; ParmLoc : 22; ParmType : type_ptr ),
(ParmName : 'actvel'; ParmLoc : 23; ParmType : type_int ),
(ParmName : 'bnderr'; ParmLoc : 24; ParmType : type_int ),
(ParmName : 'extvelocity'; ParmLoc : 25; ParmType : type_ptr ),
(ParmName : 'follow'; ParmLoc : 26; ParmType : type_ptr ),
(ParmName : 'pwm'; ParmLoc : 27; ParmType : type_int ),
(ParmName : 'homeposp'; ParmLoc : 28; ParmType : type_long ),
(ParmName : 'phasek'; ParmLoc : 30; ParmType : type_long ),
(ParmName : 'phasea'; ParmLoc : 32; ParmType : type_long ),
(ParmName : 'encp'; ParmLoc : 34; ParmType : type_long ),
(ParmName : 'desvel'; ParmLoc : 36; ParmType : type_long ),
(ParmName : 'timeout'; ParmLoc : 38; ParmType : type_uint ),
(ParmName : 'sync'; ParmLoc : 39; ParmType : type_flag ),
(ParmName : 'kk'; ParmLoc : 40; ParmType : type_int ),
(ParmName : 'kff'; ParmLoc : 41; ParmType : type_uint ),
(ParmName : 'kp'; ParmLoc : 42; ParmType : type_uint ),
(ParmName : 'kd'; ParmLoc : 43; ParmType : type_uint ),
(ParmName : 'ka'; ParmLoc : 44; ParmType : type_uint ),
(ParmName : 'ki'; ParmLoc : 45; ParmType : type_ulong ),
(ParmName : 'kih'; ParmLoc : 46; ParmType : type_uint ),
(ParmName : 'kil'; ParmLoc : 47; ParmType : type_uint ),
(ParmName : 'kf0'; ParmLoc : 48; ParmType : type_uint ),
(ParmName : 'kf1'; ParmLoc : 49; ParmType : type_uint ),
(ParmName : 'kf2'; ParmLoc : 50; ParmType : type_uint ),
(ParmName : 'kf3'; ParmLoc : 51; ParmType : type_uint ),
(ParmName : 'kdfil'; ParmLoc : 52; ParmType : type_uint ),
(ParmName : 'driveplus'; ParmLoc : 53; ParmType : type_uint ),
(ParmName : 'driveminus'; ParmLoc : 54; ParmType : type_uint ),
(ParmName : 'desposd'; ParmLoc : 56; ParmType : type_double ),
(ParmName : 'desposf'; ParmLoc : 56; ParmType : type_long ),
(ParmName : 'despos'; ParmLoc : 58; ParmType : type_long ),
(ParmName : 'velocity'; ParmLoc : 60; ParmType : type_long ),
(ParmName : 'accelf'; ParmLoc : 62; ParmType : type_int ),
(ParmName : 'accel'; ParmLoc : 63; ParmType : type_long ),
(ParmName : 'jerk'; ParmLoc : 65; ParmType : type_long ),
(ParmName : 'breakpoint'; ParmLoc : 67; ParmType : type_long ),
(ParmName : 'nextproblock'; ParmLoc : 69; ParmType : type_ptr ),
(ParmName : 'nextpos'; ParmLoc : 70; ParmType : type_long ),
(ParmName : 'slewlimit'; ParmLoc : 72; ParmType : type_long ),
(ParmName : 'startpos'; ParmLoc : 74; ParmType : type_long ),
(ParmName : 'delta'; ParmLoc : 76; ParmType : type_long ),
(ParmName : 'velocityf'; ParmLoc : 78; ParmType : type_int ),
(ParmName : 'checkpos'; ParmLoc : 80; ParmType : type_long ),
(ParmName : 'decelpos'; ParmLoc : 82; ParmType : type_long ),
(ParmName : 'fixup'; ParmLoc : 84; ParmType : type_long ),
(ParmName : 'preslewvel'; ParmLoc : 86; ParmType : type_long ),
(ParmName : 'preslewpos'; ParmLoc : 88; ParmType : type_long ),
(ParmName : 'integral'; ParmLoc : 90; ParmType : type_long ),
(ParmName : 'integralovf'; ParmLoc : 92; ParmType : type_int ),
(ParmName : 'stopathome'; ParmLoc : 93; ParmType : type_flag ),
(ParmName : 'skip'; ParmLoc : 94; ParmType : type_flag ),
(ParmName : 'lastpos'; ParmLoc : 95; ParmType : type_uint ),
(ParmName : 'lastvelocity'; ParmLoc : 96; ParmType : type_int ),
(ParmName : 'gphasef'; ParmLoc : 97; ParmType : type_flag ),
(ParmName : 'gphasek'; ParmLoc : 98; ParmType : type_long ),
(ParmName : 'gphasea'; ParmLoc : 100; ParmType : type_long ),
(ParmName : 'prescale'; ParmLoc : 102; ParmType : type_uint ),
(ParmName : 'slow'; ParmLoc : 103; ParmType : type_flag ),
(ParmName : 'flagxor'; ParmLoc : 104; ParmType : type_uint ),
(ParmName : 'flagand'; ParmLoc : 105; ParmType : type_uint ),
(ParmName : 'userstatus'; ParmLoc : 106; ParmType : type_uint ),
(ParmName : 'cntcntlp'; ParmLoc : 107; ParmType : type_uint ),
(ParmName : 'cntclrp'; ParmLoc : 108; ParmType : type_flag ),
(ParmName : 'pwmgena'; ParmLoc : 109; ParmType : type_uint ),
(ParmName : 'motori'; ParmLoc : 110; ParmType : type_uint ),
(ParmName : 'dira'; ParmLoc : 111; ParmType : type_uint ),
(ParmName : 'ena'; ParmLoc : 112; ParmType : type_uint ),
(ParmName : 'outport'; ParmLoc : 113; ParmType : type_uint ),
(ParmName : 'inport'; ParmLoc : 114; ParmType : type_uint ),
(ParmName : 'analog0'; ParmLoc : 115; ParmType : type_uint ),
(ParmName : 'analog1'; ParmLoc : 116; ParmType : type_uint ),
(ParmName : 'analog2'; ParmLoc : 117; ParmType : type_uint ),
(ParmName : 'eventfirst'; ParmLoc : 118; ParmType : type_uint ),
(ParmName : 'event1'; ParmLoc : 118; ParmType : type_uint ),
(ParmName : 'event2'; ParmLoc : 124; ParmType : type_uint ),
(ParmName : 'event3'; ParmLoc : 130; ParmType : type_uint ),
(ParmName : 'event4'; ParmLoc : 135; ParmType : type_uint ),
(ParmName : 'event5'; ParmLoc : 142; ParmType : type_uint ),
(ParmName : 'event6'; ParmLoc : 148; ParmType : type_uint ),
(ParmName : 'event7'; ParmLoc : 154; ParmType : type_uint ),
(ParmName : 'event8'; ParmLoc : 160; ParmType : type_uint ),
(ParmName : 'event9'; ParmLoc : 166; ParmType : type_uint ),
(ParmName : 'event10'; ParmLoc : 172; ParmType : type_uint ),
(ParmName : 'event11'; ParmLoc : 178; ParmType : type_uint ),
(ParmName : 'event12'; ParmLoc : 184; ParmType : type_uint ),
(ParmName : 'event13'; ParmLoc : 190; ParmType : type_uint ),
(ParmName : 'event14'; ParmLoc : 196; ParmType : type_uint ),
(ParmName : 'event15'; ParmLoc : 202; ParmType : type_uint ),
(ParmName : 'event16'; ParmLoc : 208; ParmType : type_uint ),
(ParmName : 'event17'; ParmLoc : 214; ParmType : type_uint ),
(ParmName : 'event18'; ParmLoc : 220; ParmType : type_uint ),
(ParmName : 'event19'; ParmLoc : 226; ParmType : type_uint ),
(ParmName : 'event20'; ParmLoc : 232; ParmType : type_uint ),
(ParmName : 'eventlast'; ParmLoc : 232; ParmType : type_uint ),
(ParmName : 'icdfifocount'; ParmLoc : 238; ParmType : type_uint ),
(ParmName : 'irbfifocount'; ParmLoc : 239; ParmType : type_uint ),
(ParmName : 'ififowrite'; ParmLoc : $400; ParmType : type_uint ),
(ParmName : 'qcdfifocount'; ParmLoc : 240; ParmType : type_uint ),
(ParmName : 'qrbfifocount'; ParmLoc : 241; ParmType : type_uint ),
(ParmName : 'qfifowrite'; ParmLoc : $800; ParmType : type_uint ),
(ParmName : 'icdfifosize'; ParmLoc : 242; ParmType : type_uint ),
(ParmName : 'qcdfifosize'; ParmLoc : 243; ParmType : type_uint ),
(ParmName : 'irbfifosize'; ParmLoc : 244; ParmType : type_uint ),
(ParmName : 'qrbfifosize'; ParmLoc : 245; ParmType : type_uint ),
(ParmName : 'cputype'; ParmLoc : 246; ParmType : type_uint ),
(ParmName : 'controltype'; ParmLoc : 247; ParmType : type_uint ),
(ParmName : 'swrevision'; ParmLoc : 248; ParmType : type_uint ),
(ParmName : 'naxis'; ParmLoc : 249; ParmType : type_uint ),
(ParmName : 'zero'; ParmLoc : 250; ParmType : type_int ),
(ParmName : 'false'; ParmLoc : 250; ParmType : type_flag ),
(ParmName : 'one'; ParmLoc : 251; ParmType : type_int ),
(ParmName : 'true'; ParmLoc : 252; ParmType : type_flag ),
(ParmName : 'minusone'; ParmLoc : 252; ParmType : type_int ),
(ParmName : 'sysclk'; ParmLoc : 253; ParmType : type_long ),
(ParmName : 'hwrevision'; ParmLoc : 255; ParmType : type_uint ),
(ParmName : 'ififoreadcount'; ParmLoc : 238; ParmType : type_uint ),
(ParmName : 'ififowritecount'; ParmLoc : 239; ParmType : type_uint ),
(ParmName : 'qfiforeadcount'; ParmLoc : 240; ParmType : type_uint ),
(ParmName : 'qfifowritecount'; ParmLoc : 241; ParmType : type_uint ),
(ParmName : 'phaselead'; ParmLoc : 0; ParmType : type_int ),
(ParmName : 'motorangle'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'motorphase'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'homeoffset'; ParmLoc : 0; ParmType : type_int ),
(ParmName : 'postscale'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'ledaxis'; ParmLoc : 0; ParmType : type_ptr ),
(ParmName : 'led'; ParmLoc : 0; ParmType : type_ptr ),
(ParmName : 'gevents'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'firstgevent'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'geventfirst'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'gevent1'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'geventlast'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'lastgevent'; ParmLoc : 0; ParmType : type_uint ),
(ParmName : 'address'; ParmLoc : 1; ParmType : type_ebyte ),
(ParmName : 'baudsel'; ParmLoc : 2; ParmType : type_ebyte ),
(ParmName : 'serialmode'; ParmLoc : 3; ParmType : type_ebyte ),
(ParmName : 'loadparam'; ParmLoc : 6; ParmType : type_ebyte ),
(ParmName : 'stepdirena'; ParmLoc : 7; ParmType : type_ebyte ));
